#define NULL ((void*)0)
typedef unsigned long size_t;  // Customize by platform.
typedef long intptr_t; typedef unsigned long uintptr_t;
typedef long scalar_t__;  // Either arithmetic or pointer type.
/* By default, we understand bool (as a convenience). */
typedef int bool;
#define false 0
#define true 1

/* Forward declarations */
typedef  struct TYPE_2__   TYPE_1__ ;

/* Type definitions */
typedef  int /*<<< orphan*/  h2o_token_t ;
typedef  int /*<<< orphan*/  h2o_iovec_t ;
struct TYPE_2__ {int /*<<< orphan*/  const buf; } ;

/* Variables and functions */
 int H2O_MAX_TOKENS ; 
 int /*<<< orphan*/  const* H2O_TOKEN_ACCEPT ; 
 int /*<<< orphan*/  const* H2O_TOKEN_ACCEPT_CHARSET ; 
 int /*<<< orphan*/  const* H2O_TOKEN_ACCEPT_ENCODING ; 
 int /*<<< orphan*/  const* H2O_TOKEN_ACCEPT_LANGUAGE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_ACCEPT_RANGES ; 
 int /*<<< orphan*/  const* H2O_TOKEN_ACCESS_CONTROL_ALLOW_ORIGIN ; 
 int /*<<< orphan*/  const* H2O_TOKEN_AGE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_ALLOW ; 
 int /*<<< orphan*/  const* H2O_TOKEN_AUTHORITY ; 
 int /*<<< orphan*/  const* H2O_TOKEN_AUTHORIZATION ; 
 int /*<<< orphan*/  const* H2O_TOKEN_CACHE_CONTROL ; 
 int /*<<< orphan*/  const* H2O_TOKEN_CACHE_DIGEST ; 
 int /*<<< orphan*/  const* H2O_TOKEN_CONNECTION ; 
 int /*<<< orphan*/  const* H2O_TOKEN_CONTENT_DISPOSITION ; 
 int /*<<< orphan*/  const* H2O_TOKEN_CONTENT_ENCODING ; 
 int /*<<< orphan*/  const* H2O_TOKEN_CONTENT_LANGUAGE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_CONTENT_LENGTH ; 
 int /*<<< orphan*/  const* H2O_TOKEN_CONTENT_LOCATION ; 
 int /*<<< orphan*/  const* H2O_TOKEN_CONTENT_RANGE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_CONTENT_TYPE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_COOKIE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_DATE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_EARLY_DATA ; 
 int /*<<< orphan*/  const* H2O_TOKEN_ETAG ; 
 int /*<<< orphan*/  const* H2O_TOKEN_EXPECT ; 
 int /*<<< orphan*/  const* H2O_TOKEN_EXPIRES ; 
 int /*<<< orphan*/  const* H2O_TOKEN_FROM ; 
 int /*<<< orphan*/  const* H2O_TOKEN_HOST ; 
 int /*<<< orphan*/  const* H2O_TOKEN_HTTP2_SETTINGS ; 
 int /*<<< orphan*/  const* H2O_TOKEN_IF_MATCH ; 
 int /*<<< orphan*/  const* H2O_TOKEN_IF_MODIFIED_SINCE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_IF_NONE_MATCH ; 
 int /*<<< orphan*/  const* H2O_TOKEN_IF_RANGE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_IF_UNMODIFIED_SINCE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_KEEP_ALIVE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_LAST_MODIFIED ; 
 int /*<<< orphan*/  const* H2O_TOKEN_LINK ; 
 int /*<<< orphan*/  const* H2O_TOKEN_LOCATION ; 
 int /*<<< orphan*/  const* H2O_TOKEN_MAX_FORWARDS ; 
 int /*<<< orphan*/  const* H2O_TOKEN_METHOD ; 
 int /*<<< orphan*/  const* H2O_TOKEN_PATH ; 
 int /*<<< orphan*/  const* H2O_TOKEN_PROXY_AUTHENTICATE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_PROXY_AUTHORIZATION ; 
 int /*<<< orphan*/  const* H2O_TOKEN_RANGE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_REFERER ; 
 int /*<<< orphan*/  const* H2O_TOKEN_REFRESH ; 
 int /*<<< orphan*/  const* H2O_TOKEN_RETRY_AFTER ; 
 int /*<<< orphan*/  const* H2O_TOKEN_SCHEME ; 
 int /*<<< orphan*/  const* H2O_TOKEN_SERVER ; 
 int /*<<< orphan*/  const* H2O_TOKEN_SET_COOKIE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_STATUS ; 
 int /*<<< orphan*/  const* H2O_TOKEN_STRICT_TRANSPORT_SECURITY ; 
 int /*<<< orphan*/  const* H2O_TOKEN_TE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_TRANSFER_ENCODING ; 
 int /*<<< orphan*/  const* H2O_TOKEN_UPGRADE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_USER_AGENT ; 
 int /*<<< orphan*/  const* H2O_TOKEN_VARY ; 
 int /*<<< orphan*/  const* H2O_TOKEN_VIA ; 
 int /*<<< orphan*/  const* H2O_TOKEN_WWW_AUTHENTICATE ; 
 int /*<<< orphan*/  const* H2O_TOKEN_X_COMPRESS_HINT ; 
 int /*<<< orphan*/  const* H2O_TOKEN_X_FORWARDED_FOR ; 
 int /*<<< orphan*/  const* H2O_TOKEN_X_REPROXY_URL ; 
 int /*<<< orphan*/  const* H2O_TOKEN_X_TRAFFIC ; 
 TYPE_1__* h2o__tokens ; 
 int /*<<< orphan*/  memcmp (char const*,char*,int) ; 

const h2o_token_t *h2o_lookup_token(const char *name, size_t len)
{
    switch (len) {
    case 2:
        switch (name[1]) {
        case 'e':
            if (memcmp(name, "t", 1) == 0)
                return H2O_TOKEN_TE;
            break;
        }
        break;
    case 3:
        switch (name[2]) {
        case 'a':
            if (memcmp(name, "vi", 2) == 0)
                return H2O_TOKEN_VIA;
            break;
        case 'e':
            if (memcmp(name, "ag", 2) == 0)
                return H2O_TOKEN_AGE;
            break;
        }
        break;
    case 4:
        switch (name[3]) {
        case 'e':
            if (memcmp(name, "dat", 3) == 0)
                return H2O_TOKEN_DATE;
            break;
        case 'g':
            if (memcmp(name, "eta", 3) == 0)
                return H2O_TOKEN_ETAG;
            break;
        case 'k':
            if (memcmp(name, "lin", 3) == 0)
                return H2O_TOKEN_LINK;
            break;
        case 'm':
            if (memcmp(name, "fro", 3) == 0)
                return H2O_TOKEN_FROM;
            break;
        case 't':
            if (memcmp(name, "hos", 3) == 0)
                return H2O_TOKEN_HOST;
            break;
        case 'y':
            if (memcmp(name, "var", 3) == 0)
                return H2O_TOKEN_VARY;
            break;
        }
        break;
    case 5:
        switch (name[4]) {
        case 'e':
            if (memcmp(name, "rang", 4) == 0)
                return H2O_TOKEN_RANGE;
            break;
        case 'h':
            if (memcmp(name, ":pat", 4) == 0)
                return H2O_TOKEN_PATH;
            break;
        case 'w':
            if (memcmp(name, "allo", 4) == 0)
                return H2O_TOKEN_ALLOW;
            break;
        }
        break;
    case 6:
        switch (name[5]) {
        case 'e':
            if (memcmp(name, "cooki", 5) == 0)
                return H2O_TOKEN_COOKIE;
            break;
        case 'r':
            if (memcmp(name, "serve", 5) == 0)
                return H2O_TOKEN_SERVER;
            break;
        case 't':
            if (memcmp(name, "accep", 5) == 0)
                return H2O_TOKEN_ACCEPT;
            if (memcmp(name, "expec", 5) == 0)
                return H2O_TOKEN_EXPECT;
            break;
        }
        break;
    case 7:
        switch (name[6]) {
        case 'd':
            if (memcmp(name, ":metho", 6) == 0)
                return H2O_TOKEN_METHOD;
            break;
        case 'e':
            if (memcmp(name, ":schem", 6) == 0)
                return H2O_TOKEN_SCHEME;
            if (memcmp(name, "upgrad", 6) == 0)
                return H2O_TOKEN_UPGRADE;
            break;
        case 'h':
            if (memcmp(name, "refres", 6) == 0)
                return H2O_TOKEN_REFRESH;
            break;
        case 'r':
            if (memcmp(name, "refere", 6) == 0)
                return H2O_TOKEN_REFERER;
            break;
        case 's':
            if (memcmp(name, ":statu", 6) == 0)
                return H2O_TOKEN_STATUS;
            if (memcmp(name, "expire", 6) == 0)
                return H2O_TOKEN_EXPIRES;
            break;
        }
        break;
    case 8:
        switch (name[7]) {
        case 'e':
            if (memcmp(name, "if-rang", 7) == 0)
                return H2O_TOKEN_IF_RANGE;
            break;
        case 'h':
            if (memcmp(name, "if-matc", 7) == 0)
                return H2O_TOKEN_IF_MATCH;
            break;
        case 'n':
            if (memcmp(name, "locatio", 7) == 0)
                return H2O_TOKEN_LOCATION;
            break;
        }
        break;
    case 9:
        switch (name[8]) {
        case 'c':
            if (memcmp(name, "x-traffi", 8) == 0)
                return H2O_TOKEN_X_TRAFFIC;
            break;
        }
        break;
    case 10:
        switch (name[9]) {
        case 'a':
            if (memcmp(name, "early-dat", 9) == 0)
                return H2O_TOKEN_EARLY_DATA;
            break;
        case 'e':
            if (memcmp(name, "keep-aliv", 9) == 0)
                return H2O_TOKEN_KEEP_ALIVE;
            if (memcmp(name, "set-cooki", 9) == 0)
                return H2O_TOKEN_SET_COOKIE;
            break;
        case 'n':
            if (memcmp(name, "connectio", 9) == 0)
                return H2O_TOKEN_CONNECTION;
            break;
        case 't':
            if (memcmp(name, "user-agen", 9) == 0)
                return H2O_TOKEN_USER_AGENT;
            break;
        case 'y':
            if (memcmp(name, ":authorit", 9) == 0)
                return H2O_TOKEN_AUTHORITY;
            break;
        }
        break;
    case 11:
        switch (name[10]) {
        case 'r':
            if (memcmp(name, "retry-afte", 10) == 0)
                return H2O_TOKEN_RETRY_AFTER;
            break;
        }
        break;
    case 12:
        switch (name[11]) {
        case 'e':
            if (memcmp(name, "content-typ", 11) == 0)
                return H2O_TOKEN_CONTENT_TYPE;
            break;
        case 's':
            if (memcmp(name, "max-forward", 11) == 0)
                return H2O_TOKEN_MAX_FORWARDS;
            break;
        case 't':
            if (memcmp(name, "cache-diges", 11) == 0)
                return H2O_TOKEN_CACHE_DIGEST;
            break;
        }
        break;
    case 13:
        switch (name[12]) {
        case 'd':
            if (memcmp(name, "last-modifie", 12) == 0)
                return H2O_TOKEN_LAST_MODIFIED;
            break;
        case 'e':
            if (memcmp(name, "content-rang", 12) == 0)
                return H2O_TOKEN_CONTENT_RANGE;
            break;
        case 'h':
            if (memcmp(name, "if-none-matc", 12) == 0)
                return H2O_TOKEN_IF_NONE_MATCH;
            break;
        case 'l':
            if (memcmp(name, "cache-contro", 12) == 0)
                return H2O_TOKEN_CACHE_CONTROL;
            if (memcmp(name, "x-reproxy-ur", 12) == 0)
                return H2O_TOKEN_X_REPROXY_URL;
            break;
        case 'n':
            if (memcmp(name, "authorizatio", 12) == 0)
                return H2O_TOKEN_AUTHORIZATION;
            break;
        case 's':
            if (memcmp(name, "accept-range", 12) == 0)
                return H2O_TOKEN_ACCEPT_RANGES;
            break;
        }
        break;
    case 14:
        switch (name[13]) {
        case 'h':
            if (memcmp(name, "content-lengt", 13) == 0)
                return H2O_TOKEN_CONTENT_LENGTH;
            break;
        case 's':
            if (memcmp(name, "http2-setting", 13) == 0)
                return H2O_TOKEN_HTTP2_SETTINGS;
            break;
        case 't':
            if (memcmp(name, "accept-charse", 13) == 0)
                return H2O_TOKEN_ACCEPT_CHARSET;
            break;
        }
        break;
    case 15:
        switch (name[14]) {
        case 'e':
            if (memcmp(name, "accept-languag", 14) == 0)
                return H2O_TOKEN_ACCEPT_LANGUAGE;
            break;
        case 'g':
            if (memcmp(name, "accept-encodin", 14) == 0)
                return H2O_TOKEN_ACCEPT_ENCODING;
            break;
        case 'r':
            if (memcmp(name, "x-forwarded-fo", 14) == 0)
                return H2O_TOKEN_X_FORWARDED_FOR;
            break;
        case 't':
            if (memcmp(name, "x-compress-hin", 14) == 0)
                return H2O_TOKEN_X_COMPRESS_HINT;
            break;
        }
        break;
    case 16:
        switch (name[15]) {
        case 'e':
            if (memcmp(name, "content-languag", 15) == 0)
                return H2O_TOKEN_CONTENT_LANGUAGE;
            if (memcmp(name, "www-authenticat", 15) == 0)
                return H2O_TOKEN_WWW_AUTHENTICATE;
            break;
        case 'g':
            if (memcmp(name, "content-encodin", 15) == 0)
                return H2O_TOKEN_CONTENT_ENCODING;
            break;
        case 'n':
            if (memcmp(name, "content-locatio", 15) == 0)
                return H2O_TOKEN_CONTENT_LOCATION;
            break;
        }
        break;
    case 17:
        switch (name[16]) {
        case 'e':
            if (memcmp(name, "if-modified-sinc", 16) == 0)
                return H2O_TOKEN_IF_MODIFIED_SINCE;
            break;
        case 'g':
            if (memcmp(name, "transfer-encodin", 16) == 0)
                return H2O_TOKEN_TRANSFER_ENCODING;
            break;
        }
        break;
    case 18:
        switch (name[17]) {
        case 'e':
            if (memcmp(name, "proxy-authenticat", 17) == 0)
                return H2O_TOKEN_PROXY_AUTHENTICATE;
            break;
        }
        break;
    case 19:
        switch (name[18]) {
        case 'e':
            if (memcmp(name, "if-unmodified-sinc", 18) == 0)
                return H2O_TOKEN_IF_UNMODIFIED_SINCE;
            break;
        case 'n':
            if (memcmp(name, "content-dispositio", 18) == 0)
                return H2O_TOKEN_CONTENT_DISPOSITION;
            if (memcmp(name, "proxy-authorizatio", 18) == 0)
                return H2O_TOKEN_PROXY_AUTHORIZATION;
            break;
        }
        break;
    case 25:
        switch (name[24]) {
        case 'y':
            if (memcmp(name, "strict-transport-securit", 24) == 0)
                return H2O_TOKEN_STRICT_TRANSPORT_SECURITY;
            break;
        }
        break;
    case 27:
        switch (name[26]) {
        case 'n':
            if (memcmp(name, "access-control-allow-origi", 26) == 0)
                return H2O_TOKEN_ACCESS_CONTROL_ALLOW_ORIGIN;
            break;
        }
        break;
    }

    return NULL;
}

int h2o_iovec_is_token(const h2o_iovec_t *buf)
{
    return &h2o__tokens[0].buf <= buf && buf <= &h2o__tokens[H2O_MAX_TOKENS - 1].buf;
}

