#define NULL ((void*)0)
typedef unsigned long size_t;  // Customize by platform.
typedef long intptr_t; typedef unsigned long uintptr_t;
typedef long scalar_t__;  // Either arithmetic or pointer type.
/* By default, we understand bool (as a convenience). */
typedef int bool;
#define false 0
#define true 1

/* Forward declarations */

/* Type definitions */
typedef  int int32_t ;
typedef  int /*<<< orphan*/  git_config ;

/* Variables and functions */
 int /*<<< orphan*/  cl_assert (int) ; 
 int /*<<< orphan*/  cl_fixture_cleanup (char*) ; 
 int /*<<< orphan*/  cl_fixture_sandbox (char*) ; 
 int /*<<< orphan*/  cl_git_pass (int /*<<< orphan*/ ) ; 
 int /*<<< orphan*/  git_config_delete_entry (int /*<<< orphan*/ *,char*) ; 
 int /*<<< orphan*/  git_config_free (int /*<<< orphan*/ *) ; 
 int /*<<< orphan*/  git_config_get_int32 (int*,int /*<<< orphan*/ *,char*) ; 
 int /*<<< orphan*/  git_config_open_ondisk (int /*<<< orphan*/ **,char*) ; 
 int /*<<< orphan*/  git_config_set_int32 (int /*<<< orphan*/ *,char*,int) ; 

void test_config_add__initialize(void)
{
	cl_fixture_sandbox("config/config10");
}

void test_config_add__cleanup(void)
{
	cl_fixture_cleanup("config10");
}

void test_config_add__to_existing_section(void)
{
	git_config *cfg;
	int32_t i;

	cl_git_pass(git_config_open_ondisk(&cfg, "config10"));
	cl_git_pass(git_config_set_int32(cfg, "empty.tmp", 5));
	cl_git_pass(git_config_get_int32(&i, cfg, "empty.tmp"));
	cl_assert(i == 5);
	cl_git_pass(git_config_delete_entry(cfg, "empty.tmp"));
	git_config_free(cfg);
}

void test_config_add__to_new_section(void)
{
	git_config *cfg;
	int32_t i;

	cl_git_pass(git_config_open_ondisk(&cfg, "config10"));
	cl_git_pass(git_config_set_int32(cfg, "section.tmp", 5));
	cl_git_pass(git_config_get_int32(&i, cfg, "section.tmp"));
	cl_assert(i == 5);
	cl_git_pass(git_config_delete_entry(cfg, "section.tmp"));
	git_config_free(cfg);
}

