#define NULL ((void*)0)
typedef unsigned long size_t;  // Customize by platform.
typedef long intptr_t; typedef unsigned long uintptr_t;
typedef long scalar_t__;  // Either arithmetic or pointer type.
/* By default, we understand bool (as a convenience). */
typedef int bool;
#define false 0
#define true 1

/* Forward declarations */
typedef  struct TYPE_3__   TYPE_1__ ;

/* Type definitions */
struct cp {int id; char* enc; char* name; int /*<<< orphan*/ * desc; } ;
struct TYPE_3__ {int CodePage; int MaxCharSize; char* CodePageName; } ;
typedef  int DWORD ;
typedef  TYPE_1__ CPINFOEX ;

/* Variables and functions */
 scalar_t__ GetCPInfoEx (int,int /*<<< orphan*/ ,TYPE_1__*) ; 
 int /*<<< orphan*/  IsValidCodePage (int) ; 
 int MB_ERR_INVALID_CHARS ; 
 int WC_ERR_INVALID_CHARS ; 
 struct cp* cp_map ; 
 int /*<<< orphan*/  printf (char*,...) ; 

int
main(int argc, char **argv)
{
	DWORD cp;
	CPINFOEX info;
	struct cp *cur;
	int rnd = 0;

	/*if (argc < 2) {
		printf("Usage: cpinfoex cp_id\n");
		return 0;
	}

	cp = atoi(argv[1]);*/
#if 0
/* Ref:
    http://www.iana.org/assignments/character-sets/character-sets.xhtml
    https://msdn.microsoft.com/en-us/goglobal/bb964653
    http://www.unicode.org/Public/MAPPINGS/VENDORS/MICSFT/
 */
#endif
	/*
	struct php_win32_cp {
		DWORD id;
		DWORD to_w_fl;
		DWORD from_w_fl;
		DWORD char_size;
		char *name;
		char *enc;
		char *desc;
	};
	*/
	/*printf("struct php_win32_cp {\n\tDWORD id;\n\tDWORD to_w_fl;\n\tDWORD from_w_fl;\n\tDWORD char_size;\n\tchar *name;\n\tchar *enc;\n\tchar *desc;\n};\n\n"); */
	printf("/* Autogenerated file. Update cp_enc_map_gen.c and regen like \n"
	" cp_enc_map_gen.exe > cp_enc_map.c \n*/\n\n");
	printf("static const struct php_win32_cp php_win32_cp_map[] = {");

	cur = &cp_map[0];

#ifdef ORDER_IT
	while (rnd <= 2 && ++rnd && (cur = &cp_map[0]))
#endif
	while (cur->desc != NULL) {
		if (!IsValidCodePage(cur->id)) {
#ifdef ORDER_IT
			if (2 == rnd)
#endif
			printf("\t/* %u is invalid */\n", cur->id);
			//printf("#if 0\n\t{ %u, 0, \"%s\", \"%s\" },\n#endif\n", cur->id, cur->name, cur->desc);
		} else if (GetCPInfoEx(cur->id, 0, &info)) {
			DWORD to_w_fl = 0, from_w_fl = 0;

			if (65001U == cur->id || 54936U == cur->id) {
				from_w_fl = WC_ERR_INVALID_CHARS;
				to_w_fl = MB_ERR_INVALID_CHARS;
			}

			//printf("\t{ %u, %u, \"%s\", \"%s\" },\n", cur->id, info.MaxCharSize, cur->name, cur->desc);
			if (!cur->enc[0]) {
#ifdef ORDER_IT
				if (2 == rnd)
#endif
				//printf("\t/* { %u, %u, \"%s\", NULL, \"%s\" }, */\n", info.CodePage, info.MaxCharSize, cur->name, info.CodePageName);
				printf("\t{ %u, %u, %u, %u, \"%s\", NULL, \"%s\" },\n", info.CodePage, to_w_fl, from_w_fl, info.MaxCharSize, cur->name, info.CodePageName);
			} else {
#ifdef ORDER_IT
				if (1 == rnd)
#endif
				printf("\t{ %u, %u, %u, %u, \"%s\", \"%s\", \"%s\" },\n", info.CodePage, to_w_fl, from_w_fl, info.MaxCharSize, cur->name, cur->enc, info.CodePageName);
			}
		}
		cur++;
	}

	printf("};\n\n");

	return 0;
}

